/***************************************************************************
                   httpfunc.cpp  -  test suite for basic http

    $Id: httpfunc.cpp,v 1.15 2004/05/19 15:53:14 ewald-arnold Exp $

***************************************************************************/

/**************************************************************************
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 ***************************************************************************/

#include <ulxmlrpcpp.h>  // always first header

#include <iostream>
 
#include <ulxr_http_protocol.h>


int main(int /*argc*/, char ** /*argv*/)
{
  ulxr::HttpProtocol http (0, ULXR_PCHAR("123"));

  const char *http_msg =
     "HTTP/1.1 \n"
     " 200 OK\n"
     "Connection: Close\n"
     "Content-Length: 42\n"
     "Content-Type: text/xml\n"
     "\n"
     "12345678901234567890\n"
     "abcasdf8901234567890\n";

  const char *http_msg2 =
     "HTTP/1.1 200 OK\r\n"
     "Connection     : Close\r\n"
     "Host           : me.at.home\r\n"
     "Content-Length : 44\r\n"
     "Content-Type   : text/xml;\r\n"
     " encoding=utf-8;\r\n"
     "\r\n"
     "kasdklfjasldkjfaksjf\r\n"
     "abcasdf8901234567890\r\n";

  char *buff;
  long buff_len;
  int success = 0;

  try
  {
        buff = (char*)http_msg2;
        buff_len = strlen(buff);
        http.resetConnection();
        http.connectionMachine(buff, buff_len);
        ULXR_COUT << ULXR_PCHAR("len2: ") << buff_len << std::endl;
        ULXR_COUT << ULXR_PCHAR("body2:\n") << buff << std::endl;


        buff = (char*)http_msg;
        buff_len = strlen(buff);
        http.resetConnection();
        http.connectionMachine(buff, buff_len);
        ULXR_COUT << ULXR_PCHAR("len: ") << buff_len << std::endl;
        ULXR_COUT << ULXR_PCHAR("body:\n") << buff << std::endl;


        buff = (char*)http_msg2;
        buff_len = strlen(buff);
        http.resetConnection();
        long ptr = buff_len;
        bool done = false;
        while (ptr > 0 && !done)
        {
        buff_len = 1;
        done = ulxr::Protocol::ConnBody == http.connectionMachine(buff, buff_len);
        --ptr;
        }
        ULXR_COUT << ULXR_PCHAR("len: ") << ptr << std::endl;
        ULXR_COUT << ULXR_PCHAR("body:\n") << buff << std::endl;
  }
  catch(...)
  {
    success = 1;
  }
  return success;
}
